%global momorel 1
%global artsver 1.5.6
%global artsrel 2m
%global qtver 3.3.7
%global kdever 3.5.6
%global kdelibsrel 6m
%global qtdir %{_libdir}/qt3
%global kdedir /usr
%global md5sum_src0 418f9ecac5756f7bc79863596dee7f34

Summary: program that can generate and solve sudoku (en.wikipedia.org/wiki/Sudoku)  puzzles
Name: ksudoku
Version: 0.4
Release: %{momorel}m%{?dist}
License: GPL
URL: http://ksudoku.sourceforge.net/
Group: Amusements/Games
%NoSource 0 http://dl.sourceforge.net/sourceforge/%{name}/%{name}-%{version}.tar.gz %{md5sum_src0}
Patch0: %{name}-%{version}-desktop.patch
Patch1: %{name}-%{version}-install-doc.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Requires: kdelibs >= %{kdever}-%{kdelibsrel}
BuildPreReq: qt-devel >= %{qtver}
BuildPreReq: arts-devel >= %{artsver}-%{artsrel}
BuildPreReq: kdelibs-devel >= %{kdever}-%{kdelibsrel}
BuildPreReq: mesa-libGL-devel
BuildPreReq: mesa-libGLU-devel
BuildPreReq: cmake
BuildPreReq: desktop-file-utils

%description
KSudoku is a program that can generate and solve sudoku (en.wikipedia.org/wiki/Sudoku)  puzzles 
(of different difficulty level) using a randomized least-candidate algorithm.
From version 0.3 i added a new kind of puzzles: 3d puzzles. (see changelog)
The sudoku boards currently supported are 9x9, 16x16, 25x25: but the program is fully expandable
since the algorithm is extendible to any general graph coloring problem (the board is in fact
stored as a graph and the numbers are the colors)
In order to create a playable puzzle it fills a blank sudoku grid with a completed puzzle (randomly), 
then another algorithm (to be improved with some logical constraint) removes randomly numbers from 
it checking each time that the resultant puzzle has only one solution: it is a bit slower than 
logic-based elimination tecniques but it creates puzzles that are less straight-solved (more fun).
The GUI is user-friendly and requires KDE and opengl.
Written in C++.

%prep
%setup -q

%patch0 -p1 -b .desktop~
%patch1 -p1 -b .install-doc

%build
export QTDIR=%{qtdir} KDEDIR=%{kdedir} QTLIB=%{qtdir}/lib

export CFLAGS="%{optflags}"
export CXXFLAGS="%{optflags}"

cmake . \
	-DCMAKE_BUILD_TYPE:STRING=Release \
	-DCMAKE_INSTALL_PREFIX=%{_prefix} \
	-DQT_QT_LIBRARY:FILEPATH=%{qtdir}/lib/libqt-mt.so \
	-DCMAKE_CXX_FLAGS_RELEASE:STRING="%{optflags}" \
	-DCMAKE_CXX_FLAGS:STRING="-Wall" \
	-DKDE3_MEINPROC_EXECUTABLE=%{_bindir}/meinproc \
	-DHTML_INSTALL_DIR=%{_docdir}/HTML

make %{?_smp_mflags} VERBOSE=1

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
make install DESTDIR=%{buildroot}

# install desktop file
desktop-file-install --vendor= --delete-original \
  --dir %{buildroot}%{_datadir}/applications/kde \
  --remove-category PuzzleGame \
  --add-category StrategyGame \
  %{buildroot}%{_datadir}/applications/kde/ksudoku.desktop

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-, root, root)
%doc AUTHORS COPYING ChangeLog INSTALL README TODO
%{_bindir}/ksudoku
%{_datadir}/applications/kde/ksudoku.desktop
%{_datadir}/apps/%{name}
%{_datadir}/config/ksudokurc
%{_datadir}/doc/HTML/en/%{name}
%{_datadir}/icons/*/*/*/*.png

%changelog
* Wed Mar 21 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.4-1m)
- version 0.4
- import and modify doc/CMakeLists.txt and doc/makelink.cmake from kdesvn-0.11.0

* Thu Sep 28 2006 NARITA Koichi <pulsar@momonga-linux.org>
- (0.3-1m)
- initial build for Momonga Linux 3
